QGIS Application - Bug report #14392

QGIS 2.14 has a wrong projection with rasters which are not in 4326

2016-02-29 11:57 PM - Etienne Trimaille

Status: Closed

Priority: Severe/Regression
Assignee:

Category: Projection Support

Affected QGIS version:2.14.0
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 22373

Description

With 2.14, if | try to open a raster which is not in EPSG:4326 (the raster in 3857 enclosed for instance), the EPSG displayed in QGIS is

wrong.
It displays EPSG:4326, with OTF off.

| put a screenshot with 2.14 and 2.8 :
2.14 : https://files.gitter.im/qgis/QGIS/mfWy/Selection_004.png
2.8 : https://files.gitter.im/qgis/QGIS/BOiU/Selection _005.png

We can see the map canvas is in 4326, but my coordinates are not in 4326 (both in GUI and console).

With QGIS 2.8, everything works fine.

Associated revisions

Revision 15d2be26 - 2016-03-15 02:19 AM - Nyall Dawson

Fix incorrect projection if raster or plugin layer is first layer

loaded into an empty project (fix #14392)

Revision 8cabcc79 - 2016-03-15 02:20 AM - Nyall Dawson

Fix incorrect projection if raster or plugin layer is first layer

loaded into an empty project (fix #14392)

(cherry-picked from 15d2be26f1235d9ec18b48f09376390c3a6e2d00)

History

#1 - 2016-03-01 11:59 PM - Nyall Dawson
- Status changed from Open to Feedback

| can't reproduce. Can you attach a self contained project which demonstrates this issue?

#2 - 2016-03-02 12:24 AM - Etienne Trimaille
- File issue-14392.zip added

- File wrong_coordinates.png added
I've added a zip. For me, | just have to open the raster provided in an empty project to reproduce the bug.

Tim and Nathan could replicate the issue too.

#3 - 2016-03-02 12:57 PM - Nyall Dawson

So it seems like to me that it's just the initial state of the EPSG display in the status bar which is wrong. It's showing 4326, but the project is actually in
3857. You can confirm this by opening project properties and checking the CRS - the status bar should switch back to correctly show 3857.

Can you confirm?

#4 - 2016-03-04 12:40 AM - Etienne Trimaille

You can confirm this by opening project properties and checking the CRS - the status bar should switch back to correctly show 3857.

The status bar doesn't update to 3857 here when I'm checking in the project properties.

What do you do to update the status bar ?

#5 - 2016-03-04 11:04 AM - Nyall Dawson

Just open project properties and flip to the projection tab

#6 - 2016-03-07 08:03 PM - Etienne Trimaille

Ah yes, it updates the status bar and in pyqgis too.
Will you fix the initial EPSG state ?

#7 - 2016-03-07 09:29 PM - Nyall Dawson

It's not on my personal list of stuff to fix. Maybe someone else will volunteer to look at this one.

#8 - 2016-03-14 02:46 PM - Maximilian Krambach

I'm fairly new to bughunting, so excuse me if it is a red herring and/or wrong code.
https://github.com/qgis/QGIS/blob/master/src/gui/layertree/qgslayertreemapcanvasbridge.cpp#L 146

it checks, at loading of first layers, if the layer's crs has changed. It just checks for it is vector data and if those are valid.
Including something like (see below) may resolve the issue.

QgsRasterLayer *rl = gqobject_cast<QgsRasterLayer *>( layerNode->layer()

if (rl)

{
mCanvas->setDestinationCrs( rl->crs() );
mCanvas->setMapUnits( rl->crs().mapUnits() );
break;

}

2025-04-27 2/3


https://github.com/qgis/QGIS/blob/master/src/gui/layertree/qgslayertreemapcanvasbridge.cpp#L146

#9 - 2016-03-14 05:36 PM - Nyall Dawson
- Status changed from Feedback to In Progress

Maximilian -- good catch, | can see where the regression occurred now. Fix in progress.

#10 - 2016-03-14 06:20 PM - Nyall Dawson
- Status changed from In Progress to Closed

Fixed in changeset commit:"15d2be261235d9ec18b48f09376390c3a6e2d00".

Files

raster-3857 tif 247 KB 2016-02-29 Etienne Trimaille
Sélection_048.png 162 KB 2016-02-29 Etienne Trimaille
issue-14392.zip 20.5 KB 2016-03-01 Etienne Trimaille
wrong_coordinates.png 141 KB 2016-03-01 Etienne Trimaille
